let $doc := doc("prices.xml")

for $t in distinct-values($doc//book/title)

let $p := $doc//book[title = $t]/price
let $minprice := min($p)
return
    <book title="{$t}" price="{$minprice}">
        <cheapest>{$doc//book[price = $minprice and title = $t]/source}</cheapest>
        {
            for $altbook in $doc//book
            where $altbook/price != $minprice and $altbook/title = $t
            order by $altbook/price
            return 
                <moreexpensive price="{$altbook/price}">
                    {$altbook/source}
                </moreexpensive>
        }
    </book>
